<?php

//---------------------------------------------------------------------------------
// mm_widget_imagesman
// Adds Simple photo manager TVs
//--------------------------------------------------------------------------------- 
function mm_widget_imagesman($fields, $default='{}', $roles='', $templates='') {
	global $modx, $content, $mm_fields;
	$e = &$modx->Event;
	
	if (useThisRule($roles, $templates)) {
		
		$output = '';
		
		// if we've been supplied with a string, convert it into an array 
		$fields = makeArray($fields);
		
		// Which template is this page using?
		if (isset($content['template'])) {
			$page_template = $content['template'];
		} else {
			// If no content is set, it's likely we're adding a new page at top level. 
			// So use the site default template. This may need some work as it might interfere with a default template set by MM?
			$page_template = $modx->config['default_template']; 
		}
		
		// Does this page's template use any of these TVs? If not, quit.
        $tv_count = tplUseTvs($page_template, $fields);
		
		if ($tv_count === false) {
			return;	
		}

	$site_url=$modx->config['site_url'];	

		// Insert some JS 
		$output .= includeJs($modx->config['base_url'] .'assets/plugins/managermanager/widgets/imagesman/jquery-ui-1.8.5.custom.min.js');
		//$output .= includeJs($modx->config['base_url'] .'assets/plugins/managermanager/widgets/imagesman/imagesman.js');
		// Insert some CSS 
		$output .= includeCss($modx->config['base_url'] .'assets/plugins/managermanager/widgets/imagesman/imagesman.css');
		$output .= includeCss($modx->config['base_url'] .'assets/plugins/managermanager/widgets/imagesman/smoothness/jquery-ui-1.8.5.custom.css');
			
		// Go through each of the fields supplied
		foreach ($fields as $tv) {
				
			$tv_id = $mm_fields[$tv]['fieldname'];

			$output .= ' 
				// ----------- Simple photo manager widget for  '.$tv_id.'  --------------
	var lastImageCtrl;
	var lastFileCtrl;
	var bImg = false;

	$j("#'.$tv_id.'").css("display","none");
        $j("#'.$tv_id.'").after(\'<div id="imagesman'.$tv_id.'">\
                <div class="imagesman">\
                        <div class="imginput">\
				<input type="text" id="imginputtext'.$tv_id.'" name="imginputtext'.$tv_id.'"  value="" />\
                                <input id="buttonAdd'.$tv_id.'" type="button" value="Add" onclick="BrowseServer(imginputtext'.$tv_id.')" />\
                        </div>\
                        <div id="imgpole'.$tv_id.'" class="imgpole ui-widget ui-helper-clearfix">\
                                <ul id="gallery'.$tv_id.'" class="gallery ui-helper-reset ui-helper-clearfix"></ul>\
                                <div id="trash'.$tv_id.'" class="trash ui-widget-content ui-state-default">\
                                        <h4 class="ui-widget-header"><span class="ui-icon ui-icon-trash">Trash</span> Trash</h4>\
                                </div>\
                        </div>\
                </div>\
        </div>\');

		if ($j("#'.$tv_id.'").val() == "") { 
			$j("#'.$tv_id.'").val("'.$default.'");	
		}

		var lis = ""; var maxI = 0;
		var globhash = $j("#'.$tv_id.'").val();
		globhash = eval("(" + globhash + ")");
for (var key in globhash) {
    lis +=\'<li class="ui-widget-content ui-corner-tr">\';
    lis +=\'<img src="'.$site_url.'\'+globhash[key].src+\'" alt="\'+globhash[key].alt+\'" width="96" height="72" id="num_\'+key+\'"/>\';
    lis +=\'<a href="'.$site_url.'\'+globhash[key].src+\'" title="View larger image" class="ui-icon ui-icon-zoomin">View larger</a>\';
    lis +=\'<a href="'.$site_url.'\'+globhash[key].src+\'" title="Edit alt" class="ui-icon ui-icon-pencil">Edit alt</a>\';
    lis +=\'<a href="link/to/trash/script/when/we/have/js/off" title="Delete this image" class="ui-icon ui-icon-trash">Delete image</a>\';
    lis +=\'</li>\';
    if (key>maxI) maxI = key;
}

		$j("#gallery'.$tv_id.'").html(lis);

		$j("#imginputtext'.$tv_id.'").bind( "change", function() {
			var url = $j("#imginputtext'.$tv_id.'").val();
			url = (url != "" && url.search(/http:\/\//i) == -1) ? ("'.$site_url.'" + url) : url;
			if (url != "") {
			  maxI++;
			  var $imgli = \'<li class="ui-widget-content ui-corner-tr">\';
			  $imgli += \'<img src="\'+url+\'" alt="" width="96" height="72" id="num_\'+maxI+\'" />\';
			  $imgli += \'<a href="\'+url+\'" title="View larger image" class="ui-icon ui-icon-zoomin">View larger</a>\';
			  $imgli += \'<a href="\'+url+\'" title="Edit alt" class="ui-icon ui-icon-pencil">Edit alt</a>\';
			  $imgli += \'<a href="link/to/trash/script/when/we/have/js/off" title="Delete this image" class="ui-icon ui-icon-trash">Delete image</a>\';
			  $imgli += \'</li>\';
			  addImage( $j($imgli) );
			}
			$j("#imginputtext'.$tv_id.'").val("");
			//if (bImg) { alert("Attention! This is a copy of the image."); }
			return false;
		});

		var $gallery = $j( "#gallery'.$tv_id.'" ),$trash = $j( "#trash'.$tv_id.'" );	

		$j( "li", $gallery ).draggable({
			cancel: "a.ui-icon",
			revert: "invalid",
			containment: "#imgpole'.$tv_id.'",
			helper: "clone",
			cursor: "move"
		});

		$trash.droppable({
			accept: "#gallery'.$tv_id.' > li",
			activeClass: "ui-state-highlight",
			drop: function( event, ui ) {
				deleteImage( ui.draggable );
				}
		});

		$gallery.droppable({
			accept: "#trash'.$tv_id.' li",
			activeClass: "custom-state-active",
			drop: function( event, ui ) {
				recycleImage( ui.draggable );
				}
		});

var recycle_icon = "<a href=\'link/to/recycle/script/when/we/have/js/off\' title=\'Recycle this image\' class=\'ui-icon ui-icon-refresh\'>Recycle image</a>";
var trash_icon = "<a href=\'link/to/trash/script/when/we/have/js/off\' title=\'Delete this image\' class=\'ui-icon ui-icon-trash\'>Delete image</a>";
var pencil_icon = "<a href="+\'url\'+" title=\'Edit Alt\' class=\'ui-icon ui-icon-pencil\'>Edit Alt</a>";

                function deleteImage( $item ) {
                        $item.fadeOut(function() {
                                var $list = $j( "ul", $trash ).length ?
                                        $j( "ul", $trash ) :
                                        $j( "<ul class=\'gallery ui-helper-reset\'/>" ).appendTo( $trash );

                                $item.find( "a.ui-icon-trash" ).remove();
				$item.find( "a.ui-icon-pencil" ).remove();
                                $item.append( recycle_icon ).appendTo( $list ).fadeIn(function() {
                                        $item
                                                .animate({ width: "48px" })
                                                .find( "img" )
                                                        .animate({ height: "36px" });
                                });
                        });
			var $link = $item.children("img");
			deleteImg(globhash,$link.attr("id").replace("num_",""));
			$j("#'.$tv_id.'").val(updateValue(globhash));
                }

                function recycleImage( $item ) {
                        $item.fadeOut(function() {
                                $item
                                        .find( "a.ui-icon-refresh" )
                                                .remove()
                                        .end()
                                        .css( "width", "96px")
                                        .append( trash_icon )
					.append( pencil_icon )
                                        .find( "img" )
                                                .css( "height", "72px" )
                                        .end()
                                        .appendTo( $gallery )
                                        .fadeIn();
                        });
			var $link = $item.children("img");
			addImg(globhash,$link.attr("id").replace("num_",""),$link.attr("src"),$link.attr("alt"));
			$j("#'.$tv_id.'").val(updateValue(globhash));
                }

                function addImage( $item ) {
			var $link = $item.children("img");
			addImg(globhash,$link.attr("id").replace("num_",""),$link.attr("src"),$link.attr("alt"));
			//if (!bImg) {
			   $j("#'.$tv_id.'").val(updateValue(globhash));
                           $item.fadeOut(function() {
                           $item
                             .css( "width", "96px")
			     .css( "display", "list-item")
                             .appendTo( $gallery )
			     .draggable({ cancel: "a.ui-icon", revert: "invalid", containment: "#imgpole'.$tv_id.'", helper: "clone", cursor: "move" })
                             .fadeIn();
                           });
			//}
                }

		function viewLargerImage( $link ) {
			var src = $link.attr( "href" ),
				title = $link.siblings( "img" ).attr( "alt" ),
				//$modal = $j( "img[src$=\'" + src + "\']" ).clone();
				$modal = $j( "<img src=\'" + src + "\' alt=\'" + title + "\' />" );
				//$modal.attr("title", title);

			if ( $modal.length ) {
				$modal.dialog({modal: true,width:"auto"});
			} else {
				var img = $j( "<img alt=\'" + title + "\' width=\'384\' height=\'288\' style=\'display: none; padding: 8px;\' />" )
					.attr( "src", src ).appendTo( "body" );
				setTimeout(function() {
					img.dialog({
						title: title,
						width: 400,
						modal: true
					});
				}, 1 );
			}
		}

		//$j("#dialog:ui-dialog").dialog( "destroy" );
		$j("#imagesman'.$tv_id.'").after("<div id=\'dialog'.$tv_id.'\' title=\'Edit ALT...\'><form onsubmit=\'return false;\'><fieldset></fieldset></sform></div>");

		function editAltImage( $link ) {
			var src = $link.attr( "href" ),
			title = $link.siblings( "img" ).attr( "alt" ),
			num = $link.siblings( "img" ).attr( "id" ).replace("num_",""),
			$amodal = $j("#dialog'.$tv_id.'").html( "<input id=\'altimg'.$tv_id.'\' name=\'altimg'.$tv_id.'\' type=\'text\' \
				class=\'text ui-widget-content ui-corner-all\' style=\'width:96%;\' value=\'"+title+"\' />" );
			var altname = $j( "#altimg'.$tv_id.'" ),
				allFields = $j( [] ).add( altname );

			if ( $amodal.length ) {
				$amodal.dialog({modal: true,width:300,resizable:false,
					buttons: {
						"OK": function() {
							globhash[num].alt = $j("#altimg'.$tv_id.'").val();
							$j("#num_"+num).attr("alt", $j("#altimg'.$tv_id.'").val());
							$j( this ).dialog( "close" );
						},
						Cancel: function() {
							$j( this ).dialog( "close" );
						}
					},
					close: function() {
						$j("#'.$tv_id.'").val(updateValue(globhash));
					}
			});
			} else {
				var img = $j( "<img alt=\'" + title + "\' width=\'384\' height=\'288\' style=\'display: none; padding: 8px;\' />" )
					.attr( "src", src ).appendTo( "body" );
				setTimeout(function() {
					img.dialog({
						title: title,
						width: 400,
						modal: true
					});
				}, 1 );
			}
		}

		$j( "ul.gallery > li" ).live("click", function( event ) {
			var $item = $j( this ),
				$target = $j( event.target );

			if ( $target.is( "a.ui-icon-trash" ) ) {
				deleteImage( $item );
			} else if ( $target.is( "a.ui-icon-zoomin" ) ) {
				viewLargerImage( $target );
			} else if ( $target.is( "a.ui-icon-refresh" ) ) {
				recycleImage( $item );
			}
			  else if ( $target.is( "a.ui-icon-pencil" ) ) {
				editAltImage( $target );
			}

			return false;
		});

		function addImg( hash, key, src, alt ) {
			var SiteUrl = "'.$site_url.'";
			//var i = 0;
			//bImg = false;
			//for(key in hash) if (hash.hasOwnProperty(key)) {
				//if ((hash[key].src == src.substr(SiteUrl.length)) && (hash[key].alt == alt)) { bImg = true; }
				//if (key > i) i = key;
			//}
			//if (!bImg) {
			//i++;
			hash[key] = {};
			hash[key].src = src.substr(SiteUrl.length);
			hash[key].alt = alt;
			//}
		}

		function deleteImg( hash, key ) {
			//var SiteUrl = "'.$site_url.'";
			//src = src.substr(SiteUrl.length);
			//for (var key in hash) 
			//	if((hash[key].src == src) && (hash[key].alt == alt)) delete hash[key];		
			delete hash[key];
		}

		function updateValue( hash ) {
			var tmpH = {};
			var i = 0;
			for(key in hash) if (hash.hasOwnProperty(key)) {
				i++;
				tmpH[i] = {
					src: hash[key].src,
					alt: hash[key].alt
				};
			}
			return JSON.stringify(tmpH);
		}

		if (typeof(SetUrl) != "undefined") {
			OriginalSetUrl2 = SetUrl; // Copy the existing Image browser SetUrl function
			SetUrl = function(url, width, height, alt) {    // Redefine it to also tell the preview to update
			OriginalSetUrl2(url, width, height, alt);
				$j("#imginputtext'.$tv_id.'").val(url);
				$j("#imginputtext'.$tv_id.'").trigger("change");
				}
		}
		else {
			if (typeof(SetUrl) == "undefined") {
				SetUrl = function(url, width, height, alt) {
					if(lastImageCtrl) {
						var c = document.mutate[lastImageCtrl];
						if(c) c.value = url;
						lastImageCtrl = "";
						$j("#imginputtext'.$tv_id.'").val(url);
						$j("#imginputtext'.$tv_id.'").trigger("change");
					} else { return }
				}
			}
		}

		if (typeof(BrowseServer) == "undefined") {
			BrowseServer = function(ctrl) {
				lastImageCtrl = ctrl;
				var w = screen.width * 0.7;
				var h = screen.height * 0.7;
				OpenServerBrowser("/manager/media/browser/mcpuk/browser.html?Type=images&Connector=/manager/media/browser/mcpuk/connectors/php/connector.php&ServerPath=/", w, h);
			}
		}

		if (typeof(OpenServerBrowser) == "undefined") {
			OpenServerBrowser = function(url, width, height) {
				var iLeft = (screen.width  - width) / 2 ;
				var iTop  = (screen.height - height) / 2 ;

				var sOptions = "toolbar=no,status=no,resizable=yes,dependent=yes" ;
				sOptions += ",width=" + width ;
				sOptions += ",height=" + height ;
				sOptions += ",left=" + iLeft ;
				sOptions += ",top=" + iTop ;

				var oWindow = window.open( url, "FCKBrowseWindow", sOptions ) ;
			}
		}

			';
		}
		

		$e->output($output . "\n");
		
	} // end of "if use this rule"
	
}

?>
